<?php

// ===================================================================
// Global configuration parameters:

// global $backgroundmode,$defaultzone;

//  configure script as background process job
//  leave cpu time
//  value :=  # seconds  to sleep every # of processed lines
define('_backgroundmode',1);

// define default zone
define('_DEFAULTZONE','2');

// Nodelist Data Directory if not actual script directory
// 
// $ndldir = "Q:/SERVICE/0_ARCHIV/pub/fidohist/nodelist";
// see NLSOURCE in includes/config.php

define('undef','');

// ===================================================================

// #!i:/apache/perl/bin
// package nlimport;
// use strict;
// use warnings;

/************************************************************************/
/* NLARCHIVE2.PHP                                                       */
/* ====================                                                 */
/* Program to View nodelist information from a MySQL 5 database         */
/* thru a Web search form                                               */
/*                                                                      */
/* This script relates to:                                              */
/* NDL2DB.PHP is the PHP port of the previous                           */
/* NLIMPORT.PL script v1.0                                              */
/* Copyright (c) 2007 by Alex Woick Wombaz                              */
/*                                                                      */
/* NDL2DB.PHP                                                           */
/* Copyright (c) 2007 by Ulrich Schroeter                               */
/* http://ambrosia60.dnsalias.net                                       */
/*                                                                      */
/* This program is free software. You can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2 of the License.       */
/************************************************************************/


$versionno = "2.0-RC1";
$version = $versionno;
$releasedate = "03.04.2008";
$version1 = "nlarchive2.php version ".$versionno." - ".$releasedate.",";
$version2 = "the nlarchive2 web portal";
$copyright_notice1 = "nlimport.pl Copyright (c) 2007 by Alex Woick @ Wombaz";
$copyright_notice2 = "ndl2db.php port Copyright (C) 2007,2008 by Ulrich Schroeter @ ambrosia60";
$copyright_notice3 = "This is free software, and you may redistribute it under the GPL.";


/*
#
# Change History
#
#
#   30 Nov 2007 - v1.0 (PHP)
#     Port to PHP
#
#   22 Feb 2007
#     Suggestion by Alex Woick of DB structure
#     with a PL script for import nodelist data
 */

$debut = time();

// set auto_detect_line_endings = ON in php.ini !!!

set_time_limit(0); //  0=forever   (24*60*60); // 1 day ... should be enough  ;-)
$date = date("YmdHis",time());
$progress = 1;
$no_connect = 0;
$perrn = 0;
$perrt = "";
$crlf = chr(13).chr(10);

// regexp validation string for dnsnames incl. ip addresses
// $rstrdnsname = "/^[a-z0-9\-]+\.([a-z0-9\-]+\.){0,}?[a-z]{2,6}$/i";
$rstrdnsname = "/((^[a-z0-9\-]+\.([a-z0-9\-]+\.){0,}?[a-z]{2,6}$)|(^(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])$))/i";


// define("undef",false);
$undef = false;

if (!isset($REMOTE_ADDR) && !isset($_SERVER['REMOTE_ADDR'])) {
  // register_argc_argv should be set to on: if you cannot turn this option on,
  // uncommenting the next two lines. if you then get an undefine index message
  // recomment these same two lines. Also see http://www.php.net/reserved.varia
  $argc = $_SERVER["argc"];
  $argv = $_SERVER["argv"];
  $br = "\n";
  $hr = "\n-----------------------------\n";
  $run_mode = 'cgi';
  $s_yes = "+";
  $s_no  = "X";
  $s_link = "@url";
}


// =============================================================================
//  subfunctions begin section


// ===============  subfunction(s)
function updateq($qt=0,$q) { 
  global $prefix, $db, $admin_file;
  $qas = addslashes($q);
  $insert1 = "insert into nl_queries VALUES (NULL,".$qt.",'".$qas."')";
  if (!$db->sql_query($insert1)) {
    // problem insert record 
  }
  return True;     
}
// ===============  subfunction(s) end



//  subfunctions end section
// =============================================================================


// use DBI;
// use File::Temp qw(tempfile tempdir);
// use Time::Local qw(timelocal_nocheck);
// use Digest::CRC qw(crc crc32);

// use cf;  // config (config::read)
// use Log;

//  cf::read($^O eq 'MSWin32' ? 'nlimport_win.conf' : 'nlimport.conf', {
//           LOGFILE => 'nlimport.log',
//           LOGFILE_DEBUG => 'nlimport_debug.log',
//  } );
//  replaced by config.php
// ===================================================================

$actpath = str_replace(chr(92),chr(47),getcwd());
$logfile = $actpath."/nlimport.log";
$logfile_debug = $actpath."/nlimport_debug.log";
$logfile_error = $actpath."/nlimport.err";


@require_once("includes/func_lib.php");
@require_once("includes/func_dli.php");

// echo "debug 4\r\n";
    
global $prefix, $db, $admin_file;

//  caching
//*global $hnodes,$hlinecache;
// 
//*$hnodes     = array();
//*$hlinecache = array();
// $hentry     = array();

//  # Connect to the database.
//  $cf::dbh = DBI->connect($cf::DBDSN, $cf::DBUSER, $cf::DBPASS,
//                         { RaiseError => 1,
//                           PrintError => 0,
//                           AutoCommit => 1,
//                           LongReadLen => 128000,
//                           LongTruncOk => 0 });

// # $cf::dbh->do("SET character_set_client = 'cp850'");
// # $cf::dbh->do("SET SQL_MODE=''");
// ##############################################################################

//  our $compresscfg = CompressCfg->new($cf::COMPRESSCFG);

// require_once 'configurator.php';
// require_once('configurator.php');
require_once 'includes/configurator2.php';
$compresscfg = Configurator::open('includes/compress.cfg');
$compresscfg->parse();
$pck = array();
$pck = $compresscfg->getDirectives();
// print_r($compresscfg->getDirectives());


include("includes/constants.php");
global $NLSOURCE;

include("db/db.php");


//*logfile('L',"Scanning ".$NLSOURCE);
//*logfile('D',"Scanning ".$NLSOURCE);

//   our $tmpdir = tempdir(CLEANUP => 1);
//*$tmpdir = tempnam("", "tmp");
//*if (is_file($tmpdir)) {
//*  unlink($tmpdir);
//*}
//*$tmp2dir = $actpath."/".basename($tmpdir);

//*if (is_dir($tmp2dir)) {
//*  // use existing path?
//*} else {
//*  mkdir($tmp2dir, 0700);
//*  if (is_dir($tmp2dir)) {
//*    // ok
//*  } else {
//*    logfile("E","Tempdir ".$tmp2dir." couldn't be created.");
//*    die("Tempdir couldn't be created.");
//*  }
//*}
// echo $actpath."\r\n";
// echo $tmp2dir."\r\n";
//*logfile('D',"Using temp dir: ".$tmp2dir);

#  empty_database(); # debug

//  our ($nodes, $linecache);
//  $nodes = read_nodes();
//  $linecache = read_linedata();

// $nodes = array();
// $linecache = array();


// 
//*import_subdir(str_replace(chr(92),chr(47),$NLSOURCE));

//   HTML HEADER
//   HTML HEADER END
//   HTML BODY

  $msg = "TEST NLARCHIVE2";
  $title = "NLARCHIVE2 Search Form";
 
  $today = getdate();
  $actyear = $today['year'];
  $lastyear = $actyear;

  $_GET = $HTTP_GET_VARS;
  $g_zone   = $_GET['a'];
  $g_net    = $_GET['b'];
  $g_node   = $_GET['c'];
  $g_point  = $_GET['d'];
  $g_system = $_GET['e'];
  $g_sysop  = $_GET['f'];
  $g_aq     = $_GET['aq'];  
    
  $_POST = $HTTP_POST_VARS;
  $frm_AKA      = addslashes($_POST['AKA']);
  $frm_SYSOP    = addslashes($_POST['SYSOP']);
  $frm_SYSTEM   = addslashes($_POST['SYSTEM']);  
  $tmp_SAQ      = addslashes($_POST['SA']);   // SQ or AQ
  $tmp_AQS      = addslashes($_POST['AQ2']);   // nothing,1,2,3,4,5
  $tmp_CHG      = $_POST['CHG'];   // 0,1
  $Clear_Fields =$_POST['Clear_Fields']; 



  if (($frm_AKA == "") && (($g_zone != "") && ($g_net != "") && ($g_node != "") && ($g_point != ""))) {
    $frm_AKA = $g_zone.":".$g_net."/".$g_node.".".$g_point;
  }
  if ( ($frm_SYSOP == "") && ($g_sysop!= "") ) {
    $frm_SYSOP = rawurldecode($g_sysop);
  }
  if ( ($frm_SYSTEM == "") && ($g_system!= "") ) {
    $frm_SYSTEM = rawurldecode($g_system);
  }

  if ($tmp_SAQ=="SQ") {
    // reset to simple query
    $frm_AQS = 0;
  } else {
    if ($g_aq>0) {
      $frm_AQS = intval($g_aq);
      $tmp_SAQ = "AQ";  
    } else {
      if (($tmp_AQS=="nothing") || ($tmp_AQS==="")) {
        $frm_AQS = 0;
      } else {
        $frm_AQS = intval($tmp_AQS);
        $tmp_SAQ = "AQ";
      }
    }   
  }

  // AQ SQ
  if ($tmp_SAQ=="AQ") {
    $frm_SAQ = 1;
  } else {
    $frm_SAQ = 0;
  }  


  $oscript = $_SERVER["REQUEST_URI"];
  if (at("?",$oscript)>0) {
    $oscript = substr($oscript,0,at("?",$oscript));
  } 
 
  include('includes/incheader.tpl.php');
  // echo '<p><font face="Verdana" size="2">'.$msg.'</font></p>'."\n";
  // echo $error_list;

  // if ( ($frm_AKA == "") && ($frm_SYSOP == "") && ($frm_SYSTEM == "") ) {
    // 
  //  } else {
    // 
  //  }

  if ($tmp_CHG == 1) {
    $frm_AKA    = "";
    $frm_SYSOP  = "";
    $frm_SYSTEM = "";
    // $frm_SAQ    = 0;
    // $frm_AQS    = 0;
    // $tmp_SAQ    = "SQ";
  }
  
  if ($Clear_Fields == "Clear") {
    $frm_AKA    = "";
    $frm_SYSOP  = "";
    $frm_SYSTEM = "";
    $frm_SAQ    = 0;
    $frm_AQS    = 0;
    $tmp_SAQ    = "SQ";
  }


  // echo $tmp_CHG."<br>\r\n";
  
?>

<center>



  <FONT class="header">- FIDO-HISTORY PROJECT Archive -</FONT><br>
</center>
<br>
<br>


<DIV ALIGN="CENTER"> 
<FORM METHOD="POST" ACTION="<?php echo $oscript; ?>"> 
<!-- TABLE summary="" BGCOLOR="#FFCCCC" CELLPADDING="3" BORDER="1" CAPTION="Search Criteria" -->
<TABLE summary="Search Criteria" BGCOLOR="#FFCCCC" CELLPADDING="3" BORDER="1">

  <TR VALIGN="TOP"> 
    <TD VALIGN="MIDDLE" ALIGN="CENTER"><IMG SRC="images/fido_dog.gif" HEIGHT="44" BORDER="0" alt="Fido dog"></TD> 

    <TD VALIGN="MIDDLE" ALIGN="CENTER" class="header"> 
      fidonet nodehist robot
    </TD>

    <TD VALIGN="MIDDLE" ALIGN="LEFT" rowspan="2"> 
       <INPUT type=hidden name="CHG" value="0">
       <FIELDSET><LEGEND>Query</LEGEND> 
       <INPUT NAME="SA" VALUE="SQ" TYPE="radio" <?php if ($frm_SAQ==0) { echo "CHECKED"; } ?> onclick="sachange()">Simple
       <BR>
       <BR>
       <INPUT NAME="SA" VALUE="AQ" TYPE="radio" <?php if ($frm_SAQ==1) { echo "CHECKED"; } ?> onclick="sachange()">Advanced
       </FIELDSET>
    </TD>
    
  </TR> 

  <TR> 
    <TD VALIGN="MIDDLE" ALIGN="CENTER">
      <TABLE summary="" BGCOLOR="#FFcccc" CELLPADDING="1" CELLSPACING="0"> 
		    <TR>
          <TD ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="Submit_button" CHECKED="CHECKED" VALUE="Select">
          </TD>
        </TR>
				<TR>
          <TD ALIGN="CENTER"><INPUT TYPE="SUBMIT" NAME="Clear_Fields" VALUE="Clear">
          </TD>
        </TR>
      </TABLE>
		</TD> 

    <TD VALIGN="TOP" ALIGN="LEFT"> 
      <TABLE summary="" CELLPADDING="3" CELLSPACING="0"> 
         <TR>
           <TD>
             <FIELDSET><LEGEND>[zone:]net/node</LEGEND> 
               <TABLE summary="" CELLPADDING="3" CELLSPACING="0"> 
                 <TR VALIGN="TOP"> 
                   <TD VALIGN="TOP" ALIGN="LEFT">
<?php if ($frm_SAQ==0) { ?>                   
                     <INPUT type=text name="AKA" value="<?php echo $frm_AKA; ?>"  SIZE=15 MAXLENGTH=30 STYLE="font-size:smaller; width:10em" >
<?php } else { ?>
<?php   if ($frm_AQS==4) { ?>
                     <INPUT type=text name="AKA" value="<?php echo $frm_AKA; ?>"  SIZE=15 MAXLENGTH=30 STYLE="font-size:smaller; width:10em" >
<?php   } else { ?>
                     <INPUT type=text name="AKA" value=""  SIZE=15 MAXLENGTH=30 class="txtBox" disabled>
<?php   } ?>                     
<?php } ?>                     
                   </TD>
                 </TR>
               </TABLE>
             </FIELDSET>
           </TD>
           <TD>
             <FIELDSET><LEGEND><font color="red">sysop's</font> [name ]lastname</LEGEND> 
               <TABLE summary="" CELLPADDING="3" CELLSPACING="0"> 
                 <TR VALIGN="TOP"> 
                   <TD VALIGN="TOP" ALIGN="LEFT">
<?php if ($frm_SAQ==0) { ?>                   
                     <INPUT type=text name="SYSOP" value="<?php echo $frm_SYSOP; ?>"  SIZE=15 MAXLENGTH=30 STYLE="font-size:smaller; width:10em" >
<?php } else { ?>
<?php   if (($frm_AQS==1) || ($frm_AQS==2) || ($frm_AQS==3)) { ?>
                     <INPUT type=text name="SYSOP" value="<?php echo $frm_SYSOP; ?>"  SIZE=15 MAXLENGTH=30 STYLE="font-size:smaller; width:10em" >
<?php   } else { ?>
                     <INPUT type=text name="SYSOP" value="<?php echo $frm_SYSOP; ?>"  SIZE=15 MAXLENGTH=30 class="txtBox" disabled>
<?php   } ?>                     
<?php } ?>                     

                   </TD>
                 </TR>
               </TABLE>
             </FIELDSET>
           </TD>
           <TD>
             <FIELDSET><LEGEND><font color="red">system</font> name</LEGEND> 
               <TABLE summary="" CELLPADDING="3" CELLSPACING="0"> 
                 <TR VALIGN="TOP"> 
                   <TD VALIGN="TOP" ALIGN="LEFT">
<?php if ($frm_SAQ==0) { ?>                   
                     <INPUT type=text name="SYSTEM" value="<?php echo $frm_SYSTEM; ?>"  SIZE=15 MAXLENGTH=30 STYLE="font-size:smaller; width:10em" >
<?php } else { ?>
                     <INPUT type=text name="SYSTEM" value="<?php echo $frm_SYSTEM; ?>"  SIZE=15 MAXLENGTH=30 class="txtBox" disabled>
<?php } ?>                     
                   </TD>
                 </TR>
               </TABLE>
             </FIELDSET>
           </TD>
         </TR> 
      </TABLE>
    </TD> 
  </TR> 
<?php
  if ($frm_SAQ==1) {
    // Advanced Query
?>
  <TR><TD colspan="3">  
    <DIV ALIGN="CENTER">
<!-- valign="middle"   .AQ.options[this.form.AQ.options.selectedIndex].value    -->
    <select name="AQ" onChange="aqsel(this.form.AQ.options[this.form.AQ.options.selectedIndex].value)">
       <option value="nothing" <?php if ($frm_AQS==0) { echo "selected"; } ?> STYLE="background-color : 0099cc">Select your query:</option>
       <option value="<?php echo $oscript."?aq=1"; ?>" <?php if ($frm_AQS==1) { echo "selected"; } ?>>All your node numbers you ever had</option>
       <option value="<?php echo $oscript."?aq=2"; ?>" <?php if ($frm_AQS==2) { echo "selected"; } ?>>All your different nodelist entries you ever had</option>
       <option value="<?php echo $oscript."?aq=3"; ?>" <?php if ($frm_AQS==3) { echo "selected"; } ?>>Look for all nodelists if you were listed and with which node numbers</option>
       <option value="<?php echo $oscript."?aq=4"; ?>" <?php if ($frm_AQS==4) { echo "selected"; } ?>>Count the size of a hub segment and show the development</option>
       <option value="<?php echo $oscript."?aq=5"; ?>" <?php if ($frm_AQS==5) { echo "selected"; } ?>>Who were the ZC's for how many nodelists?</option>
    </select>
    </DIV>
<?php if ($frm_AQS!=0) { ?>
    <INPUT type=hidden name="AQ2" value="<?php echo $frm_AQS; ?>">
<?php } ?>         
  </TD></TR>
<?php
  }
?>  

</TABLE>
</FORM>
</DIV>

<P ALIGN="CENTER"><FONT SIZE="1" color="#ffffff">Form based upon: 
<a class="external" target="_blank" href="http://www.writebynight.com/nodelist_search.php"><FONT SIZE="1">nodelist_search.php</font></a> Version 1.2<BR>
Copyright &copy; 2003 <A HREF="mailto:jerryschwartz@comfortable.com"><FONT SIZE="1">Jerry Schwartz</font></A> 1:142/928 and WriteByNight<br>
Nodelist lister script adopted from <a class="external" href="http://www.winramturbo.com/fnsp/arch-nodelist-diff.htm"><FONT SIZE="1">The FidoNet Showcase Project</font></a><br>
Nodelist lister script continued <a href="/fidonet/nodelist.php"><FONT SIZE="1">Fido-History-Project 3rd Generation Archive Listing</font></a><br>
Modified for NLARCHIVE2 script by U.Schroeter, <?php

  if ($actyear > 2008) {
    echo "2008-".$actyear;
  } else {
    echo "2008";
  }  
?>, (v<?php echo $version ?>)</FONT></P>



<?php

  $query0 = "select * from nodelist order by year,day";        
  $result0 = $db->sql_query($query0);
  $rrow = "";
  if ($db->sql_numrows($result0)>0) {
    $fr = False;  
    while ($row0 = $db->sql_fetchrow($result0)) {
      $lrow = "Last Nodelist in database: [ ".$row0['day']." / ".$row0['year']." ]";
      if (!$fr) {
        $fr = True;
        $frow = "First Nodelist in database: [ ".$row0['day']." / ".$row0['year']." ]";        
      }
    }
    echo "<center><TABLE summary='' border='0' width='80%'>\r\n";
    echo "<tr><td><center>\r\n";
    echo "<FONT class='smallTextFade'>".$frow." &nbsp; - &nbsp; ".$lrow."</FONT>\r\n";
    echo "</center></td></tr>\r\n";
    echo "</TABLE></center>\r\n";
    $db->sql_freeresult($result0); 
  }



 
  $query0 = "select * from nl_queries order by id_q desc limit 5";        
  $result0 = $db->sql_query($query0);
  $rrow = "";
  if ($db->sql_numrows($result0)>0) {  
    while ($row0 = $db->sql_fetchrow($result0)) {
      $tqt = intval($row0['qtype']);
      switch ($tqt) {
        case "1":      // AKA
          // if ($tqt==1) {    // AKA
          //  echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
          $taka = $row0['query'];
          $tzone = substr($taka,0,at(":",$taka));
          $traka = substr($taka,at(":",$taka)+1);
          $tnet  = substr($traka,0,at("/",$traka));
          $traka = substr($traka,at("/",$traka)+1);
          $tnode = substr($traka,0,at(".",$traka));
          $tpnt  = substr($traka,at(".",$traka)+1);
          $rrow = $rrow." [<a href='".$oscript."?a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=".$tpnt."'>".$taka."</a>]";
          break;

        case "2":      // SYSOP
          $rrow = $rrow." [<a href='".$oscript."?f=".htmlentities(urlencode($row0['query']))."'>".$row0['query']."</a>]";
          break;

        case "3":      // SYSTEM
          $rrow = $rrow." [<a href='".$oscript."?e=".htmlentities(urlencode($row0['query']))."'>".$row0['query']."</a>]";
          break;

        case "11":      // 
          //  All your node numbers you ever had
          $tsysop = substr($row0['query'],0,strlen($row0['query'])-1);
          $rrow = $rrow." [<a href='".$oscript."?aq=1&amp;f=".htmlentities(urlencode($tsysop))."'>".$row0['query']."</a>]";
          // $rrow = $rrow." [".$row0['query']."]";
          break;
          
        case "12":      // 
          // All your different nodelist entries you ever had:
          $tsysop = substr($row0['query'],0,strlen($row0['query'])-1);
          $rrow = $rrow." [<a href='".$oscript."?aq=2&amp;f=".htmlentities(urlencode($tsysop))."'>".$row0['query']."</a>]";
          // $rrow = $rrow." [".$row0['query']."]";
          break;

        case "13":      // 
          // Look for all nodelists if you were listed and with which node number count
          $tsysop = substr($row0['query'],0,strlen($row0['query'])-1);
          $rrow = $rrow." [<a href='".$oscript."?aq=3&amp;f=".htmlentities(urlencode($tsysop))."'>".$row0['query']."</a>]";
          // $rrow = $rrow." [".$row0['query']."]";
          break;

        case "14":      // Hub
          // Count the size of a hub segment and show the development
          // $rrow = $rrow." [<a href='".$oscript."?aq=4'>".$row0['query']."</a>]";

          $taka = substr($row0['query'],4);
          $tzone = substr($taka,0,at(":",$taka));
          $traka = substr($taka,at(":",$taka)+1);
          $tnet  = substr($traka,0,at("/",$traka));
          $traka = substr($traka,at("/",$traka)+1);
          if (at(".",$traka)>0) {
            $tnode = substr($traka,0,at(".",$traka));
            $tpnt  = substr($traka,at(".",$traka)+1);
          } else {
            $tnode = $traka;
            $tpnt  = 0;
          }
          $rrow = $rrow." [<a href='".$oscript."?aq=4&amp;a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=0'>".$row0['query']."</a>]";
          // $rrow = $rrow." [".$row0['query']."]";
          break;

        case "15":      // Who were the ZCs
          // Who were the ZC's for how many nodelists?
          $rrow = $rrow." [<a href='".$oscript."?aq=5'>".$row0['query']."</a>]";
          break;

        default:
          $rrow = $rrow." [".$row0['query']."]";
          break;
      }
    }
    
    echo "<center><TABLE summary='' border='0' width='80%'>\r\n";
    echo "<tr><td><center>\r\n";
    echo "<FONT class='smallTextY'>Last 5 queries: ".$rrow."</FONT>\r\n";
    echo "</center></td></tr>\r\n";
    echo "</TABLE></center>\r\n";
    $db->sql_freeresult($result0); 
  }
  $nfound = False;

// echo "frm_SAQ=".$frm_SAQ.", frm_AQS=".$frm_AQS.", frm_AKA=".$frm_AKA."<br>\r\n";

  
  if ($frm_SAQ==1) {
    // Advanced Query
    // $frm_AQS==1 .. 5

    switch ($frm_AQS) {
      case "1":
        //  All your node numbers you ever had
        if ($frm_SYSOP != "") {
          // sysop = ?
          // echo $tqAKA."<br>\r\n";
          // $rrow = $rrow." [<a href='".$oscript."?a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=".$tpnt."'>".$taka."</a>]";
          // htmlentities(urlencode(
          // $query1 = "select state, keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where sysop='".$frm_SYSOP."'";
          $query1 = "select keyword, zone, region, net, hub, node, point from nl_node where sysop='".$frm_SYSOP."'";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: All your different nodelist entries you ever had: ".$frm_SYSOP."</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================      
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            // year, day, date, count(id_nl_entry) as num_entry
            // year, day, date, zone, net, node, point, sysop
            // state, keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags
            // keyword, zone, region, net, hub, node, point
            echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            // <TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD>
            while ($row1 = $db->sql_fetchrow($result1)) {
              echo "<TR>\r\n";
              echo "<TD>".$row1['keyword']."</TD>\r\n";              
              // echo "<TD>".$row1['zone']."</TD>\r\n";
              // // echo "<TD>".$row1['num_entry']."</TD>\r\n";
              // // echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point']."</a></TD>\r\n";          
              // echo "<TD>".$row1['region']."</TD>\r\n";
              // echo "<TD>".$row1['net']."</TD>\r\n";
              // echo "<TD>".$row1['hub']."</TD>\r\n";
              // echo "<TD>".$row1['node']."</TD>\r\n";
              // echo "<TD>".$row1['point']."</TD>\r\n";
              $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
              // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
              if ($row1['keyword']=="Region" ) {
                echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['zone']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['zone']."/0</a></TD>\r\n";          
              } else {
                if ($row1['keyword']=="Host" ) {
                  echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['region']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['region']."/0</a></TD>\r\n";          
                } else {
                  echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
                }
              }  
              // echo "<TD>".$row1['region']."</TD>\r\n";

              // echo "<TD>".$row1['nodename']."</TD>\r\n";
              // echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
              // echo "<TD>".$row1['location']."</TD>\r\n";
              // echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
              // // echo "<TD>".$row1['num_nodelist']."</TD>\r\n";
              // echo "<TD>".$row1['phone']."</TD>\r\n";
              // echo "<TD>".$row1['baudrate']."</TD>\r\n";
              // echo "<TD>".$row1['flags']."</TD>\r\n";
              echo "</TR>\r\n";
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(11,$frm_SYSOP."#");
          } else {
            $nfound = True;        
          }        
        } else {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR><TR>\r\n";
          // #FFCC90
          echo "<TH bgcolor='#FFFF00' align='left'>\r\n"; //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Please enter the Sysop name you're looking for</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "</TABLE></CENTER>\r\n";
        }
        break;

      case "2":
        // All your different nodelist entries you ever had
        if ($frm_SYSOP != "") {
          // sysop = ?
          // echo $tqAKA."<br>\r\n";
          // $rrow = $rrow." [<a href='".$oscript."?a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=".$tpnt."'>".$taka."</a>]";
          // htmlentities(urlencode(
          $query1 = "select state, keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where sysop='".$frm_SYSOP."'";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: All your different nodelist entries you ever had: ".$frm_SYSOP."</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================      
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            // year, day, date, count(id_nl_entry) as num_entry
            // year, day, date, zone, net, node, point, sysop
            // state, keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags
            echo "<TR><TD class='headPara'>State</TD><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Region</TD><TD class='headPara'>System</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";
            // <TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD>
            while ($row1 = $db->sql_fetchrow($result1)) {
              echo "<TR>\r\n";
              echo "<TD>".$row1['state']."</TD>\r\n";
              echo "<TD>".$row1['keyword']."</TD>\r\n";              
              // echo "<TD>".$row1['zone']."</TD>\r\n";
              // // echo "<TD>".$row1['num_entry']."</TD>\r\n";
              // // echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point']."</a></TD>\r\n";          
              // echo "<TD>".$row1['region']."</TD>\r\n";
              // echo "<TD>".$row1['net']."</TD>\r\n";
              // echo "<TD>".$row1['hub']."</TD>\r\n";
              // echo "<TD>".$row1['node']."</TD>\r\n";
              // echo "<TD>".$row1['point']."</TD>\r\n";
              $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
              // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
              if ($row1['keyword']=="Region" ) {
                echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['zone']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['zone']."/0</a></TD>\r\n";          
              } else {
                if ($row1['keyword']=="Host" ) {
                  echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['region']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['region']."/0</a></TD>\r\n";          
                } else {
                  echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
                }
              }  
              echo "<TD>".$row1['region']."</TD>\r\n";

              // echo "<TD>".$row1['nodename']."</TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
              echo "<TD>".$row1['location']."</TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
              // echo "<TD>".$row1['num_nodelist']."</TD>\r\n";
              echo "<TD>".$row1['phone']."</TD>\r\n";
              echo "<TD>".$row1['baudrate']."</TD>\r\n";
              echo "<TD>".$row1['flags']."</TD>\r\n";
              echo "</TR>\r\n";
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(12,$frm_SYSOP."+");
          } else {
            $nfound = True;        
          }        
        } else {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR><TR>\r\n";
          // #FFCC90
          echo "<TH bgcolor='#FFFF00' align='left'>\r\n"; //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Please enter the Sysop name you're looking for</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "</TABLE></CENTER>\r\n";
        }
        break;

      case "3":
        // Look for all nodelists if you were listed and with which node numbecoucoucount
        if ($frm_SYSOP != "") {
          // sysop = ?
          // echo $tqAKA."<br>\r\n";
          // $rrow = $rrow." [<a href='".$oscript."?a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=".$tpnt."'>".$taka."</a>]";

          // htmlentities(urlencode(

          $query1 = "select year, day, date, zone, net, node, point, sysop from nodelist left join (select id_nodelist, zone, net, node, point, sysop from nl_line join nl_node using (id_nl_node) join nl_entry using (id_nl_line) where sysop='".$frm_SYSOP."') as t1 using (id_nodelist)";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: Look for all nodelists if you were listed and with which node number count: ".$frm_SYSOP."</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================      
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            // year, day, date, count(id_nl_entry) as num_entry
            // year, day, date, zone, net, node, point, sysop
            echo "<TR><TD class='headPara'>Year</TD><TD class='headPara'>Day</TD><TD class='headPara'>Date</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Sysop</TD></TR>\r\n";          
            while ($row1 = $db->sql_fetchrow($result1)) {
              if ($row1['zone']!="") {
                echo "<TR>\r\n";
                echo "<TD>".$row1['year']."</TD>\r\n";
                echo "<TD>".$row1['day']."</TD>\r\n";              
                echo "<TD>".$row1['date']."</TD>\r\n";
                // echo "<TD>".$row1['num_entry']."</TD>\r\n";
                echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point']."</a></TD>\r\n";          
                echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
                // echo "<TD>".$row1['num_nodelist']."</TD>\r\n";
                echo "</TR>\r\n";
              }
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(13,$frm_SYSOP."*");
          } else {
            $nfound = True;        
          }        
        } else {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR><TR>\r\n";
          // #FFCC90
          echo "<TH bgcolor='#FFFF00' align='left'>\r\n"; //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Please enter the Sysop name you're looking for</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "</TABLE></CENTER>\r\n";
        }
        break;

      case "4":
        // Count the size of a hub segment and show the development
        // enter HUB Aka
        // if empty AKA display: "Enter Hub AKA"
        if ($frm_AKA != "") {
          // aka = ?
          $taka = $frm_AKA;
          $tzone = substr($taka,0,at(":",$taka));
          $traka = substr($taka,at(":",$taka)+1);
          $tnet  = substr($traka,0,at("/",$traka));
          $traka = substr($traka,at("/",$traka)+1);
          if (at(".",$traka)>0) {
            $tnode = substr($traka,0,at(".",$traka));
            $tpnt  = substr($traka,at(".",$traka)+1);
          } else {
            $tnode = $traka;
            $tpnt = 0;
          }
          $tqAKA = $tzone.":".$tnet."/".$tnode;
          // echo $tqAKA."<br>\r\n";
          // $rrow = $rrow." [<a href='".$oscript."?a=".$tzone."&amp;b=".$tnet."&amp;c=".$tnode."&amp;d=".$tpnt."'>".$taka."</a>]";
          $query1 = "select year, day, date, count(id_nl_line) as num_entry from nodelist join nl_entry using (id_nodelist) join nl_line using (id_nl_line) join nl_node using (id_nl_node) where zone=".$tzone." and net=".$tnet." and hub=".$tnode." and point=0 group by year, day, date";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: Count the size of hub ".$tqAKA." segment and show the development</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================      
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            // zone, sysop, count(id_nodelist)
            // year, day, date, count(id_nl_entry) as num_entry
            echo "<TR><TD class='headPara'>Year</TD><TD class='headPara'>Day</TD><TD class='headPara'>Date</TD><TD class='headPara'># Entrys</TD></TR>\r\n";          
            while ($row1 = $db->sql_fetchrow($result1)) {
              echo "<TR>\r\n";
              echo "<TD>".$row1['year']."</TD>\r\n";
              echo "<TD>".$row1['day']."</TD>\r\n";              
              echo "<TD>".$row1['date']."</TD>\r\n";
              echo "<TD>".$row1['num_entry']."</TD>\r\n";
              // echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['zone']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['zone']."/0</a></TD>\r\n";          
              // echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
              // echo "<TD>".$row1['num_nodelist']."</TD>\r\n";
              echo "</TR>\r\n";
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(14,"Hub ".$tqAKA);
          } else {
            $nfound = True;        
          }        
        } else {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#FFFF00' align='left'>\r\n"; //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Enter HUB Aka</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "</TABLE></CENTER>\r\n";
        }
        break;

      case "5":
        // Who were the ZC's for how many nodelists?
        $query1 = "select zone, sysop, count(id_nodelist) as num_nodelist from nl_entry join nl_line using (id_nl_line) join nl_node using (id_nl_node) where keyword='Zone' group by zone, sysop order by zone";
        $result1 = $db->sql_query($query1);
        $cols = 9;
        // if ($row1 = $db->sql_fetchrow($result1)) {
        if ($db->sql_numrows($result1)>0) {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Query: Who were the ZC's for how many nodelists?</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "<tr><td>\r\n";      
          // =============================      
          echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
          // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
          // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
          // zone, sysop, count(id_nodelist)
          echo "<TR><TD class='headPara'>Zone</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Sysop</TD><TD class='headPara'># Nodelists</TD></TR>\r\n";          
          while ($row1 = $db->sql_fetchrow($result1)) {
            echo "<TR>\r\n";
            echo "<TD>".$row1['zone']."</TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['zone']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['zone']."/0</a></TD>\r\n";          
            echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
            echo "<TD>".$row1['num_nodelist']."</TD>\r\n";
            echo "</TR>\r\n";
          }
          echo "</TABLE></center>\r\n";
          echo "</td></tr></table></center>\r\n";
          updateq(15,"ZCs?");
        } else {
          $nfound = True;        
        }        
        break;

      default:        
        $nfound = True;
        break;
    }
  } else {
    // Simple Queries  
    // select keyword, zone, region, net, hub, node, point from nl_node where sysop='Steven Leeman'
    if ($frm_AKA != "") {
      //  [zone:]net/node
      if (at("/",$frm_AKA)>0) {
        $partNODE = substr($frm_AKA,at("/",$frm_AKA)+1);
        $partLEFT = substr($frm_AKA,0,at("/",$frm_AKA));
        if (at(":",$partLEFT)>0) {
          // w/ Zone
          $partNET  = substr($partLEFT,at(":",$partLEFT)+1);
          $partZONE = substr($partLEFT,0,at(":",$partLEFT));
          $query1 = "select keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where zone='".$partZONE."' AND net='".$partNET."' AND node='".$partNODE."'";
          $qAKA = $partZONE.":".$partNET."/".$partNODE;                
        } else {
          // w/o zone
          $partNET = $partLEFT;
          $partZONE = "";
          $query1 = "select keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where net='".$partNET."' AND node='".$partNODE."'";        
          $qAKA = $partNET."/".$partNODE;
        }
        $result1 = $db->sql_query($query1);
        $cols = 9;
        // if ($row1 = $db->sql_fetchrow($result1)) {
        if ($db->sql_numrows($result1)>0) {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
          if ($partZONE != "") {
            echo "<center><FONT color='#A52A2A'>Query: search for AKA '".$partZONE.":".$partNET."/".$partNODE."'</FONT></center>\r\n";
          } else {
            echo "<center><FONT color='#A52A2A'>Query: search for AKA '".$partNET."/".$partNODE."'</FONT></center>\r\n";
          }      
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "<tr><td>\r\n";      
          // =============================      
          echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
          // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
          // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
          echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Systemname</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";          
          while ($row1 = $db->sql_fetchrow($result1)) {
            echo "<TR>\r\n";
            echo "<TD>".$row1['keyword']."</TD>\r\n";
            $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
            // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
            if ($row1['keyword']=="Region" ) {
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['zone']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['zone']."/0</a></TD>\r\n";          
            } else {
              if ($row1['keyword']=="Host" ) {
                echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['region']."&amp;c=0&amp;d=0'>".$row1['zone'].":".$row1['region']."/0</a></TD>\r\n";          
              } else {
                echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
              }
            }  
            echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
            echo "<TD>".$row1['location']."</TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";
            echo "<TD>".$row1['phone']."</TD>\r\n";
            echo "<TD>".$row1['baudrate']."</TD>\r\n";
            echo "<TD>".$row1['flags']."</TD>\r\n";
            echo "</TR>\r\n";
          }
          echo "</TABLE></center>\r\n";
          echo "</td></tr></table></center>\r\n";
          updateq(1,$qAKA);
        } else {
          $nfound = True;            
        }
      } else {
        $nfound = True;
      }
    } else {
      if ($frm_SYSOP != "") {
        // $query1 = "select keyword, zone, region, net, hub, node, point from nl_node where sysop='".$frm_SYSOP."'";
        $query1 = "select keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where sysop='".$frm_SYSOP."'";
        $result1 = $db->sql_query($query1);
        $cols = 9;
        // if ($row1 = $db->sql_fetchrow($result1)) {
        if ($db->sql_numrows($result1)>0) {
          echo "<center>\r\n";      
          echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
          echo "<TR>\r\n";
          echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
          echo "<center><FONT color='#A52A2A'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</FONT></center>\r\n";
          echo "</TH>\r\n";
          echo "</TR><TR>\r\n";
          echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
          echo "</TR>\r\n";
          echo "<tr><td>\r\n";      
          // =============================      
          echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
          // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
          // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
          echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Systemname</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";          
          while ($row1 = $db->sql_fetchrow($result1)) {
            echo "<TR>\r\n";
            echo "<TD>".$row1['keyword']."</TD>\r\n";
            $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
            // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
            echo "<TD>".$row1['location']."</TD>\r\n";
            echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";          
            echo "<TD>".$row1['phone']."</TD>\r\n";
            echo "<TD>".$row1['baudrate']."</TD>\r\n";
            echo "<TD>".$row1['flags']."</TD>\r\n";
            echo "</TR>\r\n";
          }
          echo "</TABLE></center>\r\n";
          echo "</td></tr></table></center>\r\n";
          updateq(2,$frm_SYSOP);
        } else {
          $query1 = "select keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where sysop like '% ".$frm_SYSOP."'";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH  bgcolor='#A52A2A' height='5'></TH>\r\n";  // colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n";  //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================      
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD></TR>\r\n";
            echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Systemname</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";          
            while ($row1 = $db->sql_fetchrow($result1)) {
              echo "<TR>\r\n";
              echo "<TD>".$row1['keyword']."</TD>\r\n";
              $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
              // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
              echo "<TD>".$row1['location']."</TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";          
              echo "<TD>".$row1['phone']."</TD>\r\n";
              echo "<TD>".$row1['baudrate']."</TD>\r\n";
              echo "<TD>".$row1['flags']."</TD>\r\n";
              echo "</TR>\r\n";
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(2,$frm_SYSOP);
          } else {
            $nfound = True;
          }            
        }
      } else {
        if ($frm_SYSTEM != "") {
          $query1 = "select keyword, zone, region, net, hub, node, point, nodename, location, sysop, phone, baudrate, flags from nl_line join nl_node using (id_nl_node) where nodename like '".$frm_SYSTEM."%'";
          $result1 = $db->sql_query($query1);
          $cols = 9;
          // if ($row1 = $db->sql_fetchrow($result1)) {
          if ($db->sql_numrows($result1)>0) {
            echo "<center>\r\n";      
            echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
            echo "<TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#FFCC90' align='left'>\r\n"; //  colspan='".$cols."'
            echo "<center><FONT color='#A52A2A'>Query: all AKA's of System '".$frm_SYSTEM."'</FONT></center>\r\n";
            echo "</TH>\r\n";
            echo "</TR><TR>\r\n";
            echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
            echo "</TR>\r\n";
            echo "<tr><td>\r\n";      
            // =============================  
            echo "<center><TABLE summary='' BORDER='1' WIDTH='98%' CELLPADDING='3' CELLSPACING='0' bgcolor='#66cccc'>\r\n";
            // echo "<TR><TH colspan='9'>Query: all AKA's of Sysop '".$frm_SYSOP."' ever had</TH></TR>\r\n";
            // echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>Zone</TD><TD class='headPara'>Region</TD><TD class='headPara'>Net</TD><TD class='headPara'>Hub</TD><TD class='headPara'>Node</TD><TD class='headPara'>Point</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Systemname</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";
            echo "<TR><TD class='headPara'>Keyword</TD><TD class='headPara'>AKA</TD><TD class='headPara'>Uplink</TD><TD class='headPara'>Systemname</TD><TD class='headPara'>Location</TD><TD class='headPara'>Sysop</TD><TD class='headPara'>Phone</TD><TD class='headPara'>Baud</TD><TD class='headPara'>Flags</TD></TR>\r\n";          
      
            while ($row1 = $db->sql_fetchrow($result1)) {
              echo "<TR>\r\n";
              echo "<TD>".$row1['keyword']."</TD>\r\n";
              $dispAKA = $row1['zone'].":".$row1['net']."/".$row1['node'].".".$row1['point'];
              // echo "<TD><a class='srch' href='".$oscript."?".htmlentities(urlencode("a=".$row1['zone']."&b=".$row1['net']."&c=".$row1['node']."&d=".$row1['point']))."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['node']."&amp;d=".$row1['point']."'>".$dispAKA."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?a=".$row1['zone']."&amp;b=".$row1['net']."&amp;c=".$row1['hub']."&amp;d=0'>".$row1['zone'].":".$row1['net']."/".$row1['hub']."</a></TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?e=".htmlentities(urlencode($row1['nodename']))."'>".$row1['nodename']."</a></TD>\r\n";
              echo "<TD>".$row1['location']."</TD>\r\n";
              echo "<TD><a class='srch' href='".$oscript."?f=".htmlentities(urlencode($row1['sysop']))."'>".$row1['sysop']."</a></TD>\r\n";          
              echo "<TD>".$row1['phone']."</TD>\r\n";
              echo "<TD>".$row1['baudrate']."</TD>\r\n";
              echo "<TD>".$row1['flags']."</TD>\r\n";
              echo "</TR>\r\n";
            }
            echo "</TABLE></center>\r\n";
            echo "</td></tr></table></center>\r\n";
            updateq(3,$frm_SYSTEM);
          } else {
            $nfound = True;            
          }
        } else {
          $nfound = True;
        }
      }
    }    
  }  
  if ($nfound) {
    echo "<center>\r\n";      
    echo "<TABLE summary='' bgcolor='#D2B48C' border='1' width='80%'>\r\n";
    echo "<TR>\r\n";
    echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
    echo "</TR><TR>\r\n";
    echo "<TH bgcolor='#FFCC90' align='left'>\r\n"; //  colspan='".$cols."'
    if (($frm_AKA == "") && ($frm_SYSOP == "") && ($frm_SYSTEM == "") ) {
      echo "<center><FONT color='#A52A2A'>Empyt Query.<br>No results found.</FONT></center>\r\n";
    } else {
      $qtxt = "";        
      if ($frm_AKA == "") {
        if ($frm_SYSOP == "") {
          $qtxt = "Systemname = ".$frm_SYSTEM;
        } else {
          $qtxt = "Sysop = ".$frm_SYSOP;
        }
      } else {
        $qtxt = "AKA = ".$frm_AKA;            
      }
      echo "<center><FONT color='#A52A2A'>Query: ".$qtxt."<br>No results found.</FONT></center>\r\n";
    }
    echo "</TH>\r\n";
    echo "</TR><TR>\r\n";
    echo "<TH bgcolor='#A52A2A' height='5'></TH>\r\n"; //  colspan='".$cols."'
    echo "</TR>\r\n";
    echo "</TABLE></CENTER>\r\n";
  }
  include('includes/incfooter.tpl.php');

//   HTML FORM
//   HTML BODY END


  
// $nodes = array();
// $linecache = array();

//$list = update_stat();
//update_history($list);

//   $cf::dbh->disconnect;
$db->sql_close();

// remove temp dir
//*if (is_dir($tmp2dir)) {
  // remove temp path
//*  chdir($actpath);
//*  full_rmdir(basename($tmpdir));
//*}

// close logfiles
//*logfile('Q');

  
//exit 0;

?>
